<template>
  <div class="app-container">
    <el-form :model="queryParams" ref="queryRef"  v-show="showSearch" label-width="68px">
      <el-row >
				<el-col :span="6">
				  <el-form-item label="物料编号" prop="wlNo">
            <el-input
              v-model="queryParams.wlNo"
              placeholder="请输入物料编号"
              clearable
              @keyup.enter="handleQuery"
            />
          </el-form-item>
				</el-col>
				<el-col :span="4" >
					<el-form-item>
            <el-button type="primary" icon="search" size="mini" @click="handleQuery">搜索</el-button>
            <el-button icon="refresh" size="mini" @click="resetQuery">重置</el-button>
          </el-form-item>
				</el-col>
      </el-row>

    </el-form>

    <el-row :gutter="10" class="mb8">
      <el-col :span="1.5">
        <el-button
          type="primary"
          plain
          icon="Plus"
          @click="handleAdd"
          v-hasPermi="['document:mtd:add']"
        >新增</el-button>
      </el-col>
      <el-col :span="1.5">
        <el-button
          type="success"
          plain
          icon="Edit"
          :disabled="single"
          @click="handleUpdate"
          v-hasPermi="['document:mtd:edit']"
        >修改</el-button>
      </el-col>
      <el-col :span="1.5">
        <el-button
          type="danger"
          plain
          icon="Delete"
          :disabled="multiple"
          @click="handleDelete"
          v-hasPermi="['document:mtd:remove']"
        >删除</el-button>
      </el-col>
      <el-col :span="1.5">
        <el-button
          type="warning"
          plain
          icon="Download"
          @click="handleExport"
          v-hasPermi="['document:mtd:export']"
        >导出</el-button>
      </el-col>
      <el-col :span="1.5">
        <el-button
          type="warning"
          plain
          icon="Upload"
          @click="handleImport"
        >导入</el-button>
      </el-col>
      <right-toolbar v-model:showSearch="showSearch" @queryTable="getList"></right-toolbar>
    </el-row>

    <el-table v-loading="loading" :data="mtdList" @selection-change="handleSelectionChange">
      <el-table-column type="selection" width="55" align="center" />
      <el-table-column label="物料编号" align="center" prop="wlNo" />
      <el-table-column label="物料描述" align="center" prop="wlMs" />
      <el-table-column label="计量单位" align="center" prop="dw" />
      <el-table-column label="单件重量(kg)" align="center" prop="weightKg" />
      <el-table-column label="单件体积(立方米)" align="center" prop="volumeM3" />
      <el-table-column label="操作" align="center" class-name="small-padding fixed-width">
        <template #default="scope">
          <el-button link type="primary" icon="Edit" @click="handleUpdate(scope.row)" v-hasPermi="['document:mtd:edit']">修改</el-button>
          <el-button link type="primary" icon="Delete" @click="handleDelete(scope.row)" v-hasPermi="['document:mtd:remove']">删除</el-button>
        </template>
      </el-table-column>
    </el-table>
    
    <pagination
      v-show="total>0"
      :total="total"
      v-model:page="queryParams.pageNum"
      v-model:limit="queryParams.pageSize"
      @pagination="getList"
    />

    <!-- 添加或修改物料字典对话框 -->
    <el-dialog :title="title" v-model="open" width="700px" append-to-body>
      <el-form ref="mtdRef" :model="form" :rules="rules" label-width="150px">
        <el-form-item label="物料编号" prop="wlNo">
          <el-input v-model="form.wlNo" placeholder="请输入物料编号" />
        </el-form-item>
        <el-form-item label="物料描述" prop="wlMs">
          <el-input v-model="form.wlMs" placeholder="请输入物料描述" />
        </el-form-item>
        <el-form-item label="计量单位" prop="dw">
          <el-input v-model="form.dw" placeholder="请输入计量单位" />
        </el-form-item>
        <el-form-item label="单件重量(kg)" prop="weightKg">
          <el-input v-model="form.weightKg" placeholder="请输入单件重量(kg)" />
        </el-form-item>
        <el-form-item label="单件体积(立方米)" prop="volumeM3">
          <el-input v-model="form.volumeM3" placeholder="请输入单件体积(立方米)" />
        </el-form-item>
        
      </el-form>
      <template #footer>
        <div class="dialog-footer">
          <el-button type="primary" @click="submitForm">确 定</el-button>
          <el-button @click="cancel">取 消</el-button>
        </div>
      </template>
    </el-dialog>
        <!-- 导入对话框 -->
      <el-dialog title="导入" v-model="upload.open" width="400px" append-to-body>
        <el-upload ref="uploadRef" :limit="1" accept=".xlsx, .xls" :headers="upload.headers" :action="upload.url" :disabled="upload.isUploading" :on-progress="handleFileUploadProgress" :on-success="handleFileSuccess" :auto-upload="false" drag>
          <el-icon class="el-icon--upload"><upload-filled /></el-icon>
          <div class="el-upload__text">将文件拖到此处，或<em>点击上传</em></div>
          <template #tip>
            <div class="el-upload__tip text-center">
              <span>仅允许导入xls、xlsx格式文件。</span>
            </div>
          </template>
        </el-upload>
        <template #footer>
          <div class="dialog-footer">
            <el-button type="primary" @click="submitFileForm">确 定</el-button>
            <el-button @click="upload.open = false">取 消</el-button>
          </div>
        </template>
      </el-dialog>
  </div>
</template>

<script setup name="Mtd">
import { listMtd, getMtd, delMtd, addMtd, updateMtd } from "@/api/information/deliery"
import { getToken } from "@/utils/auth";
const { proxy } = getCurrentInstance()

const mtdList = ref([])
const open = ref(false)
const loading = ref(true)
const showSearch = ref(true)
const ids = ref([])
const single = ref(true)
const multiple = ref(true)
const total = ref(0)
const title = ref("")

const data = reactive({
  form: {},
  queryParams: {
    pageNum: 1,
    pageSize: 10,
    wlNo: null,
    wlMs: null,
    dw: null,
    weightKg: null,
    volumeM3: null,
    isDelete: null
  },
  rules: {
    wlNo: [
      { required: true, message: "物料编号不能为空", trigger: "blur" }
    ],
    weightKg: [
      { required: true, message: "单件重量不能为空", trigger: "blur" }
    ],
    volumeM3: [
      { required: true, message: "单件体积不能为空", trigger: "blur" }
    ],
  }
})

//文件上传--供应计划导入
const upload = reactive({
  // 是否显示弹出层（用户导入）
  open: false,
  // 弹出层标题（用户导入）
  title: "",
  // 是否禁用上传
  isUploading: false,
  // 是否更新已经存在的用户数据
  updateSupport: 0,
  // 设置上传的请求头部
  headers: { Authorization: "Bearer " + getToken() },
  // 上传的地址
  url: import.meta.env.VITE_APP_BASE_API + "/information/delivery/importData"
});

const { queryParams, form, rules } = toRefs(data)

/** 查询物料字典列表 */
function getList() {
  loading.value = true
  listMtd(queryParams.value).then(response => {
    mtdList.value = response.rows
    total.value = response.total
    loading.value = false
  })
}

// 取消按钮
function cancel() {
  open.value = false
  reset()
}

// 表单重置
function reset() {
  form.value = {
    id: null,
    wlNo: null,
    wlMs: null,
    dw: null,
    weightKg: null,
    volumeM3: null,
    createBy: null,
    createTime: null,
    updateBy: null,
    updateTime: null,
    isDelete: null
  }
  proxy.resetForm("mtdRef")
}

/** 搜索按钮操作 */
function handleQuery() {
  queryParams.value.pageNum = 1
  getList()
}

/** 重置按钮操作 */
function resetQuery() {
  proxy.resetForm("queryRef")
  handleQuery()
}

// 多选框选中数据
function handleSelectionChange(selection) {
  ids.value = selection.map(item => item.id)
  single.value = selection.length != 1
  multiple.value = !selection.length
}

/** 新增按钮操作 */
function handleAdd() {
  reset()
  open.value = true
  title.value = "添加物料字典"
}

/** 修改按钮操作 */
function handleUpdate(row) {
  reset()
  const _id = row.id || ids.value
  getMtd(_id).then(response => {
    form.value = response.data
    open.value = true
    title.value = "修改物料字典"
  })
}

/** 提交按钮 */
function submitForm() {
  proxy.$refs["mtdRef"].validate(valid => {
    if (valid) {
      if (form.value.id != null) {
        updateMtd(form.value).then(response => {
          proxy.$modal.msgSuccess("修改成功")
          open.value = false
          getList()
        })
      } else {
        addMtd(form.value).then(response => {
          proxy.$modal.msgSuccess("新增成功")
          open.value = false
          getList()
        })
      }
    }
  })
}

/** 删除按钮操作 */
function handleDelete(row) {
  const _ids = row.id || ids.value
  proxy.$modal.confirm('是否确认删除物料字典编号为"' + _ids + '"的数据项？').then(function() {
    return delMtd(_ids)
  }).then(() => {
    getList()
    proxy.$modal.msgSuccess("删除成功")
  }).catch(() => {})
}

/** 导出按钮操作 */
function handleExport() {
  proxy.download('/information/delivery/export', {
    ...queryParams.value
  }, `mtd_${new Date().getTime()}.xlsx`)
}
// 导入
function handleImport(){
  upload.open = true;
}
/**文件上传中处理 */
const handleFileUploadProgress = (event, file, fileList) => {
  upload.isUploading = true;
};

/** 文件上传成功处理 */
const handleFileSuccess = (response, file, fileList) => {
  upload.open = false;
  upload.isUploading = false;
  proxy.$refs["uploadRef"].handleRemove(file);
  proxy.$alert("<div style='overflow: auto;overflow-x: hidden;max-height: 70vh;padding: 10px 20px 0;'>" + response.msg + "</div>", "导入结果", { dangerouslyUseHTMLString: true });
  getList();
};

/** 提交上传文件 */
function submitFileForm() {
  proxy.$refs["uploadRef"].submit();
};
getList()
</script>
